//+------------------------------------------------------------------+
//|                                              PipRocket_v1_10.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"

#include <stdlib.mqh>

#define MODE_LONG 1
#define MODE_SHORT -1
#define MODE_NONE 0

extern double LotSize = 0.1;
extern int magic = 10000;

extern bool debug = true,
            useAroon = false;

string ver;
double stoploss, takeprofit;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   ver = StringConcatenate("PipRocket_v1.17 M(",Period(),")");
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
 Comment("Stop Level + Slippage: ", MarketInfo(Symbol(),MODE_STOPLEVEL)+1);


   if(!orderExists())
   {
      if(getSignal(MODE_LONG))
      {
         if(debug)
         Print("OPENING FIRST BUY");
         
         openOrder(MODE_LONG);
          makeScreenshot("Open_Long");

      }
      
      if(getSignal(MODE_SHORT))
      {
         if(debug)
         Print("OPENING FIRST SELL");
         
         openOrder(MODE_SHORT);
         makeScreenshot("Open_Short");
         
      }   
   }
   else
   {
       OrderSelect(getOrderTicket(),SELECT_BY_TICKET,MODE_TRADES);      
       
       if(OrderType() == OP_BUY)
       {
         
         stoploss = r(ObjectGet("hi.1.p1",1) );
       
               //move traling 
               if(stoploss!=0 && OrderStopLoss() <   stoploss     )
               {
                  if(debug)
                  Print("MOVING SL OP BUY");
                  
                  moveSL(OrderTicket(),stoploss);  
               }
           
           if(getSignal(MODE_SHORT))
           {
               if(debug)
               Print("REV BUY 2 SELL CO");
         
               if(closeOrder(OrderTicket(),OrderLots()))
               {
                  if(debug)
                  Print("REV BUY 2 SELL OO");
         
                  openOrder(MODE_SHORT);
                   
               }    
           }
       }
       else if(OrderType() == OP_SELL)
       {
         stoploss = r(ObjectGet("lo.1.p1",1) );
         
               //move traling  
               if(stoploss!=0 && OrderStopLoss() >  stoploss   )
               {
                  if(debug)
                  Print("MOVING SL OP SELL");
         
                  moveSL(OrderTicket(),stoploss);
               }       
           
           if(getSignal(MODE_LONG))
           {
               if(debug)
               Print("REV SELL 2 BUY CO");
               
               if( closeOrder(OrderTicket(),OrderLots()) )
               {
               
                  if(debug)
                  Print("REV SELL 2 BUY OO");
              
                  openOrder(MODE_LONG);
                   
               }    
           } 
       }
   }
   
 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
 
double r(double v)
{
   return(NormalizeDouble(v,MarketInfo(Symbol(),MODE_DIGITS)));
}
bool checkAroon(int type)
{
   if(useAroon)
   {
      double aroonUp = iCustom(Symbol(),60,"Aroon_v1",10,0,0);//blue
      double aroonDn = iCustom(Symbol(),60,"Aroon_v1",10,1,0);//red
      double aroonOsc = iCustom(Symbol(),60,"Aroon Oscilator_v1",10,50,300,2,0);
      
      
      if(type == MODE_LONG && aroonUp>aroonDn && aroonOsc > 0)
      return (true);
      else if(type == MODE_SHORT && aroonUp<aroonDn && aroonOsc < 0)
      return (true);
      else
      return (false);   
   }
   
   return (true);
     
}
bool getSignal(int type )
{ 
   
   
   double ma1.p1 = r(ObjectGet("ma1.p1",1));
   double ma2.p1 = r(ObjectGet("ma2.p1",1));
   double ma3.p1 = r(ObjectGet("ma3.p1",1));     
     
   double ma1.p2 = r(ObjectGet("ma1.p2",1));
   double ma2.p2 = r(ObjectGet("ma2.p2",1));
   double ma3.p2 = r(ObjectGet("ma3.p2",1));
   
   double ma1.p3 = r(ObjectGet("ma1.p3",1));
   double ma2.p3 = r(ObjectGet("ma2.p3",1));
   double ma3.p3 = r(ObjectGet("ma3.p3",1));   
   
   double ma1.p4 = r(ObjectGet("ma1.p4",1));
   double ma2.p4 = r(ObjectGet("ma2.p4",1));
   double ma3.p4 = r(ObjectGet("ma3.p4",1));   
   
   double lcf.p1 = r(ObjectGet("lcf.p1",1));
   double lcf.p2 = r(ObjectGet("lcf.p2",1));
   double lcf.p3 = r(ObjectGet("lcf.p3",1));
   double lcf.p4 = r(ObjectGet("lcf.p4",1));
   
   double hcf.p1 = r(ObjectGet("hcf.p1",1));
   double hcf.p2 = r(ObjectGet("hcf.p2",1));
   double hcf.p3 = r(ObjectGet("hcf.p3",1));
   double hcf.p4 = r(ObjectGet("hcf.p4",1));
   
   double lo1.p1 = r(ObjectGet("lo.1.p1",1));
   double lo1.p2 = r(ObjectGet("lo.1.p2",1));
   double lo1.p3 = r(ObjectGet("lo.1.p3",1));
   double lo1.p4 = r(ObjectGet("lo.1.p4",1));
   
   double lo2.p1 = r(ObjectGet("lo.2.p1",1));
   double lo2.p2 = r(ObjectGet("lo.2.p2",1));
   double lo2.p3 = r(ObjectGet("lo.2.p3",1));
   double lo2.p4 = r(ObjectGet("lo.2.p4",1));
   
   
   double hi1.p1 = r(ObjectGet("hi.1.p1",1));
   double hi1.p2 = r(ObjectGet("hi.1.p2",1));
   double hi1.p3 = r(ObjectGet("hi.1.p3",1));
   double hi1.p4 = r(ObjectGet("hi.1.p4",1));
   
   double hi2.p1 = r(ObjectGet("hi.2.p1",1));
   double hi2.p2 = r(ObjectGet("hi.2.p2",1));
   double hi2.p3 = r(ObjectGet("hi.2.p3",1));
   double hi2.p4 = r(ObjectGet("hi.2.p4",1));
   
    
   
   if(type == MODE_LONG)
   {
      //setup 1/5 
      if(            
          lcf.p1 != 0 
         && lcf.p2 != 0 
         && lcf.p1 == lcf.p2 
         && lo1.p1 == lo1.p2
         && lo1.p1 != 0 
         && lo1.p2 != 0
         && lcf.p1 > ma1.p1
         && lcf.p2 > ma1.p2
         && Bid > lcf.p1
         
         && checkAroon(MODE_LONG)
         )
      {
         
       
         
         return(true);
      }
      
       if(          
          lo1.p1 != 0 
         && lo1.p2 != 0 
         && lo1.p1 == lo1.p2 
         && lo2.p1 == lo2.p2
         && lo2.p1 != 0 
         && lo2.p2 != 0
         && lo1.p1 > ma1.p1
         && lo1.p2 > ma1.p2
         && Bid > lo1.p1
         
         && checkAroon(MODE_LONG)
         )
      {
         
         return(true);
      }
      
      
      
            
      //setup 5/15 
      if(         
         lcf.p2 != 0 
         && lcf.p3 != 0 
         && lcf.p2 == lcf.p3 
         && lo1.p2 == lo1.p3
         && lo1.p2 != 0 
         && lo1.p3 != 0
         && lcf.p2 > ma1.p2
         && lcf.p3 > ma1.p3
         && Bid > lcf.p2
         
         && checkAroon(MODE_LONG)
         )
      {
         
       
         return(true);
      }
      
       if(           
          lo1.p2 != 0 
         && lo1.p3 != 0 
         && lo1.p2 == lo1.p3
         && lo2.p2 == lo2.p3
         && lo2.p2 != 0 
         && lo2.p3 != 0
         && lo1.p2 > ma1.p2
         && lo1.p3 > ma1.p3
         && Bid > lo1.p2
         
         && checkAroon(MODE_LONG)
         )
      {
         
         return(true);
      }
      
      
      
      
      
      //setup 15/60 
      if(          
         lcf.p3 != 0 
         && lcf.p4 != 0 
         && lcf.p3 == lcf.p4 
         && lo1.p3 == lo1.p4
         && lo1.p3 != 0 
         && lo1.p4 != 0
         && lcf.p3 > ma1.p3
         && lcf.p4 > ma1.p4
         && Bid > lcf.p3
         
         
         && checkAroon(MODE_LONG)
         )
      {
         
        
         return(true);
      }
      
       if(   ma1.p3 > ma2.p3 
         && ma1.p4 > ma2.p4
         && ma1.p4 > ma3.p4          
         && lo1.p3 != 0 
         && lo1.p4 != 0 
         && lo1.p3 == lo1.p4
         && lo2.p3 == lo2.p4
         && lo2.p3 != 0 
         && lo2.p4 != 0
         && lo1.p3 > ma1.p3
         && lo1.p4 > ma1.p4
         && Bid > lo1.p3
         && Bid > ma1.p3
         && Bid > ma1.p4
         && checkAroon(MODE_LONG)
         )
      {
         
         return(true);
      }
      
      
       
      
   }
   else
   {
      //setup 1/5 
      if(           
         hcf.p1 != 0 
         && hcf.p2 != 0 
         && hcf.p1 == hcf.p2 
         && hi1.p1 == hi1.p2
         && hi1.p1 != 0 
         && hi1.p2 != 0
         && hcf.p1 < ma1.p1
         && hcf.p2 < ma1.p2
         && Bid < hcf.p1
         
         && checkAroon(MODE_SHORT)
         )
      {
         
      
         return(true);
      }
      
       if(           
          hi1.p1 != 0 
         && hi1.p2 != 0 
         && hi1.p1 == hi1.p2 
         && hi2.p1 == hi2.p2
         && hi2.p1 != 0 
         && hi2.p2 != 0
         && hi1.p1 < ma1.p1
         && hi1.p2 < ma1.p2
         && Bid < hi1.p1
         
         && checkAroon(MODE_SHORT)
         )
      {
         
         return(true);
      }
      
      
     
      
      //setup 5/15 
      if(          
          hcf.p2 != 0 
         && hcf.p3 != 0 
         && hcf.p2 == hcf.p3 
         && hi1.p2 == hi1.p3
         && hi1.p2 != 0 
         && hi1.p3 != 0
         && hcf.p2 < ma1.p2
         && hcf.p3 < ma1.p3
         && Bid < hcf.p2
         
         && checkAroon(MODE_SHORT)
         )
      {
         
       
         
         return(true);
      }
      
       if(        
          hi1.p2 != 0 
         && hi1.p3 != 0 
         && hi1.p2 == hi1.p3
         && hi2.p2 == hi2.p3
         && hi2.p2 != 0 
         && hi2.p3 != 0
         && hi1.p2 < ma1.p2
         && hi1.p3 < ma1.p3
         && Bid < hi1.p2
         
         && checkAroon(MODE_SHORT)
         )
      {
        
         return(true);
      }
      
      
       
      
      
      //setup 15/60 
      if(         
          hcf.p3 != 0 
         && hcf.p4 != 0 
         && hcf.p3 == hcf.p4 
         && hi1.p3 == hi1.p4
         && hi1.p3 != 0 
         && hi1.p4 != 0
         && hcf.p3 < ma1.p3
         && hcf.p4 < ma1.p4
         && Bid < hcf.p3
         
         && checkAroon(MODE_SHORT)
         )
      {
       
        
         return(true);
      }
      
       if(        
         hi1.p3 != 0 
         && hi1.p4 != 0 
         && hi1.p3 == hi1.p4
         && hi2.p3 == hi2.p4
         && hi2.p3 != 0 
         && hi2.p4 != 0
         && hi1.p3 < ma1.p3
         && hi1.p4 < ma1.p4
         && Bid < hi1.p3
         
         && checkAroon(MODE_SHORT)
         )
      {
         
         return(true);
      }
      
      
            
      
   }
   
   return (false);
}
//+------------------------------------------------------------------+
bool moveSL(int ticket,double stoploss)
{
   
   if(!IsTradeAllowed())
   return (false);
   
   if(MathAbs(Ask-stoploss)/Point < MarketInfo(Symbol(),MODE_STOPLEVEL)) 
   {
      Print("STOP LOSS too close ",Bid," SL ",stoploss);
      return(false);
   }
   
   int error;
   
   int MAXRETRIES = 5;
   int retries = 0;
   while(!OrderModify(ticket,OrderOpenPrice(), stoploss, OrderTakeProfit(), 0,CLR_NONE))
   {
      error = GetLastError();
      
      if(error>1)   
      Print("MoveSL failed with error #",ErrorDescription(error)," CurrentSL ",OrderStopLoss()," NewSL ",stoploss);
       
      Sleep(1000);
            
      RefreshRates();
            
      if(retries >= MAXRETRIES) 
      return(false);
      else
      retries++;
   }
   
}  
//+------------------------------------------------------------------+

int getMagic() 
{
 
   if(Symbol()=="EURUSD")
   return (123401);
   else if(Symbol()=="GBPUSD")
   return (123402);
   else if(Symbol()=="USDJPY")
   return (123403);
   else if(Symbol()=="USDCHF")
   return (123404);
   else if(Symbol()=="AUDUSD")
   return (123405);
   else if(Symbol()=="USDCAD")
   return (123406);
   else if(Symbol()=="EURJPY")
   return (123407);
   else if(Symbol()=="NZDUSD")
   return (123408);
   else if(Symbol()=="GBPJPY")
   return (123409);
   else
   return(magic);
}


//+------------------------------------------------------------------+

bool orderExists()
{
    int total = OrdersTotal();
    for(int cnt = 0 ;cnt<=total;cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == getMagic()) 
      return(true);
    } 
    return(false); 
}

//+------------------------------------------------------------------+

int getOrderTicket()
{
    int total = OrdersTotal();
    for(int cnt = 0 ;cnt<=total;cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == getMagic()) 
      return(OrderTicket());
    } 
   return(-1); 
}

//+------------------------------------------------------------------+
 
bool closeOrder(int ticket, double lots)
{
   if(!IsTradeAllowed())
   return (false);
   
   int MAXRETRIES = 5;
   int retries = 0;
   OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
   int error;
   if(OrderType() == OP_BUY)
   {
      while(!OrderClose(ticket, lots, Bid, 3, Red))
      {
      
            error = GetLastError();
            
            if(error>1)
            Print("OrderClose failed with error #",ErrorDescription(error));
            
            Sleep(1000);
            
            RefreshRates();
         
            if(retries >= MAXRETRIES) 
              return(false);
            else
              retries++;
        }

   }
   else
   {
         while(!OrderClose(ticket, OrderLots(), Ask, 3, Red))
         {
            error = GetLastError();
            
            if(error>1)
            Print("OrderClose failed with error #",ErrorDescription(error));
            
            Sleep(1000);
            
            RefreshRates();
         
            if(retries >= MAXRETRIES) 
              return(false);
            else
              retries++;
        }

   }
   
   return (true);
}

//+------------------------------------------------------------------+

int openOrder(int type )
  {
   
   if(!IsTradeAllowed())
   {
      return (-1);
   }
   
  int error = 0;
  int ticket = 0;
  
  double slsp = MarketInfo(Symbol(),MODE_STOPLEVEL)+1;
  double stoplevel = MarketInfo(Symbol(),MODE_STOPLEVEL);
  
  double tp1=0,tp2=0,tp3=0,tp4=0;
  
   if( type == MODE_SHORT )
   {
      takeprofit = 0;
      stoploss = 0;
         
      while(true)
      {
        if(MathAbs(Bid-takeprofit)/Point < stoplevel)
        {
         Print("TP too close");
         return(0); 
        }
        
        if(MathAbs(Bid-stoploss)/Point < stoplevel) 
        {
         Print("SL too close");
         return(0);
        }
        
        
         tp1 = r( ObjectGet("hi.1.p2",1) );
         tp2 = r( ObjectGet("hi.2.p2",1) );
         tp3 = r( ObjectGet("hi.3.p2",1) );
         tp4 = r( ObjectGet("hi.4.p2",1) );
        
        if( Bid > tp1 && (MathAbs(Bid-tp1)/Point > slsp) && tp1!=0)
        {
         takeprofit = tp1; 
        }
        else if( Bid > tp2 && (MathAbs(Bid-tp2)/Point > slsp) && tp2!=0)
        {
         takeprofit = tp2; 
        }
        else if( Bid > tp3 && (MathAbs(Bid-tp3)/Point > slsp) && tp3!=0)
        {
         takeprofit = tp3; 
        }
        else if( Bid > tp4 && (MathAbs(Bid-tp4)/Point > slsp) && tp4!=0)
        {
         takeprofit = tp4; 
        }
        else
        {
         Print("SHORT Cannot set TP | Bid ",Bid," tp1 ",tp1," tp2 ",tp2," tp3 ",tp3," tp4 ",tp4 ," SLSP ",slsp );
         return(0);
        }

        

        
        stoploss = r(ObjectGet("lo.1.p1",1) );
        
        Print("SHORT tp:",takeprofit," sl:",stoploss," hi1p2:",r( ObjectGet("hi.1.p2",1) )," lo1p1",r(ObjectGet("lo.1.p1",1) ));
        
        if(takeprofit!=0 && stoploss!=0)
        ticket = OrderSend(Symbol(),OP_SELL,LotSize,Bid,1,stoploss,takeprofit,ver,getMagic(),0,Green);
        else
        {
         Print("TPSL ERROR tp",takeprofit," SL ",stoploss);
         return(0);
        }
        
         
        if(ticket<=0)
        {
            error=GetLastError();
            
            if(error>1)
            Print("SELL ORDER ERROR:", ErrorDescription(error)," BID ",Bid," TP ",takeprofit," SL ",stoploss);
            
      
            
          if(error==134) break;            // not enough money
          if(error==135) RefreshRates();   // prices changed
          break;
        }
        else { OrderPrint(); break; }
        //---- 1 second wait
        Sleep(1000);
      } 
   }
   else if( type == MODE_LONG )
   {
      while(true)
      {
        if(MathAbs(Ask-takeprofit)/Point < stoplevel )
        {
         Print("TP too close");
         return(0);
        }
        
        if(MathAbs(Ask-stoploss)/Point < stoplevel) 
        {
         Print("SL too close");
         return(0);
        }
        
        
         tp1 = r(ObjectGet("lo.1.p2",1) );
         tp2 = r(ObjectGet("lo.2.p2",1) );
         tp3 = r(ObjectGet("lo.3.p2",1) );
         tp4 = r(ObjectGet("lo.4.p2",1) );
        
        if( Ask < tp1 && (MathAbs(tp1-Ask)/Point > slsp) && tp1!=0)
        {
         takeprofit = tp1; 
        }
        else if( Ask < tp2 && (MathAbs(tp2-Ask)/Point > slsp) && tp2!=0)
        {
         takeprofit = tp2; 
        }
        else if( Ask < tp3 && (MathAbs(tp3-Ask)/Point > slsp) && tp3!=0)
        {
         takeprofit = tp3; 
        }
        else if( Ask < tp4 && (MathAbs(tp4-Ask)/Point > slsp) && tp4!=0)
        {
         takeprofit = tp4; 
        }
        else
        {
         Print("LONG Cannot set TP | Ask ",Ask," tp1 ",tp1," tp2 ",tp2," tp3 ",tp3," tp4 ",tp4," SLSP ",slsp );
         return(0);
        }
       
        
        stoploss = r(ObjectGet("hi.1.p1",1) );
        
        Print("LONG tp:",takeprofit," sl:",stoploss," lo1p2:",r(ObjectGet("lo.1.p2",1) )," hi1p1:",r(ObjectGet("hi.1.p1",1) ));
        
        if(takeprofit!=0 && stoploss!=0)
        ticket = OrderSend(Symbol(),OP_BUY,LotSize,Ask,1,stoploss,takeprofit,ver,getMagic(),0,Green);
        else
        {
         Print("TPSL ERROR tp",takeprofit," SL ",stoploss);
         return(0);
        }
        
        if(ticket<=0)
        {
            error=GetLastError();
            
            if(error>1)
            Print("BUY ORDER ERROR:", ErrorDescription(error)," Ask ",Ask," TP ",takeprofit," SL ",stoploss);
            
      
            
          if(error==134) break;            // not enough money
          if(error==135) RefreshRates();   // prices changed
          break;
        }
        else { OrderPrint(); break; }
        //---- 1 second wait
        Sleep(1000);
      }
   }
    
   
    return (ticket);
  }
  void makeScreenshot(string comment = "")
{
   string month,day,hour,min,sec;
   
   if(StringLen(DoubleToStr(Month(),0))==1)
   month = StringConcatenate(0,Month());
   else
   month = Month();
   
   if(StringLen(DoubleToStr(Day(),0))==1)
   day = StringConcatenate(0,Day());
   else
   day = Day();
   
   if(StringLen(DoubleToStr(Hour(),0))==1)
   hour = StringConcatenate(0,Hour());
   else
   hour = Hour();
   
   if(StringLen(DoubleToStr(Minute(),0))==1)
   min = StringConcatenate(0,Minute());
   else
   min = Minute();
   
   if(StringLen(DoubleToStr(Seconds(),0))==1)
   sec = StringConcatenate(0,Seconds());
   else
   sec = Seconds();
   
   string prefix = StringConcatenate(ver,"_",Period(),"_",Symbol(),"_",Year(),"-",month,"-",day," ",hour,".",min,".",sec,"__",comment,".gif");
   
    ScreenShot(prefix,1024,780,-1,3,0);
    
}